#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

struct hill{
    int l,r;
    int id;
};

bool cmp(hill fr,hill sc){
    return fr.l<sc.l;
}

bool cmp2(hill fr,hill sc){
    return fr.r<sc.r;
}

const int inf=1e9+7;

int n,k,h[MAXN];
long long t[MAXN],ans;

int previous_hill[MAXN],next_hill[MAXN];
hill s[MAXN];
vector<int> g[MAXN],sol;

int dist[MAXN];
bool vis[MAXN];
queue<int> q;

stack<int> st;

void calc_ranges(){
    st.push(0);

    for(int i=1;i<=n;i++){
        while(!st.empty() and h[i]>h[st.top()]){
            st.pop();
        }
        previous_hill[i]=st.top();
        st.push(i);
    }

    while(!st.empty())st.pop();

    st.push(n+1);
    for(int i=n;i>=1;i--){
        while(!st.empty() and h[i]>h[st.top()]){
            st.pop();
        }
        next_hill[i]=st.top();
        st.push(i);
    }
}

bool cross(hill fr,hill sc){
    if(fr.r+1<sc.l)return false;
    if(sc.r+1<fr.l)return false;

    return true;
}

void bfs(int x){
    for(int i:g[x]){
        if(vis[i])continue;

        vis[i]=true; dist[i]=dist[x]+1;
        q.push(i);
    }
}

void build_graph(){

    sort(s+1,s+n+1,cmp);
    for(int i=1;i<=n;i++){
        for(int f=i+1;f<=n;f++){
            if(!cross(s[i],s[f]) or abs(i-f)>20)break;

            g[s[i].id].push_back(s[f].id);
            g[s[f].id].push_back(s[i].id);
        }

        for(int f=i-1;f>=1;f--){
            if(!cross(s[i],s[f]) or abs(i-f)>20)break;

            g[s[i].id].push_back(s[f].id);
            g[s[f].id].push_back(s[i].id);
        }
    }

    sort(s+1,s+n+1,cmp2);
    for(int i=1;i<=n;i++){
        for(int f=i+1;f<=n;f++){
            if(!cross(s[i],s[f]) or abs(i-f)>20)break;

            g[s[i].id].push_back(s[f].id);
            g[s[f].id].push_back(s[i].id);
        }

        for(int f=i-1;f>=1;f--){
            if(!cross(s[i],s[f]) or abs(i-f)>20)break;

            g[s[i].id].push_back(s[f].id);
            g[s[f].id].push_back(s[i].id);
        }
    }


    for(int i=1;i<=n;i++){
        if(s[i].l==1){

            q.push(s[i].id);
            dist[s[i].id]=1; 
            vis[s[i].id]=true;
        }
    }
}

void findpath(int x){
    sol.push_back(x);

    if(dist[x]==0)return;

    for(int i:g[x]){
        if(dist[i]+1==dist[x]){
            findpath(i); return;
        }
    }
}

bool check(long long maxt,bool solution){

    int pt=0;
    for(int i=1;i<=n;i++){
        while(pt<n and t[pt+1]-t[i]<=maxt)pt++;
        s[i].r=min(next_hill[i],pt);
        s[i].id=i;
    }

    pt=n+1;
    for(int i=n;i>=1;i--){
        while(pt>1 and t[i]-t[pt-1]<=maxt)pt--;
        s[i].l=max(previous_hill[i],pt);
    }

    for(int i=1;i<=n;i++){
        g[i].clear(); vis[i]=false;
        s[i].id=i;
    }

    build_graph();

    while(!q.empty()){
        bfs(q.front());
        q.pop();
    }

    int res=n+1,endv=0;
    for(int i=1;i<=n;i++){
        if(s[i].r==n and dist[s[i].id]<res){
            res=dist[s[i].id]; endv=s[i].id;
        }
    }

    if(solution)findpath(endv);

    return res<=k;
}

long long bin(){
    long long l=0,r=t[n]+5,mid;

    while(l+1<r){
        mid=(l+r)/2;

        if(check(mid,false)){
            r=mid;
        }else{
            l=mid;
        }
    }

    return r;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<=n;i++){
        cin>>h[i];
    }
    h[0]=h[n+1]=inf;

    for(int i=2;i<=n;i++){
        cin>>t[i];
        t[i]+=t[i-1];
    }

    calc_ranges();
    ans=bin();
    
    if(ans==t[n]+5){
        cout<<"-1\n";
        return 0;
    }

    check(ans,true);
    while(sol.size()<k)sol.push_back(n);

    cout<<ans<<"\n";
    for(int i:sol)cout<<i<<" ";
    cout<<"\n";

    return 0;
}