#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

struct hill{
    int l,r;
};

const int inf=1e9+7;

int n,k,h[MAXN];
long long t[MAXN],ans;

int previous_hill[MAXN],next_hill[MAXN];
hill s[MAXN];
vector<int> g[MAXN],sol;

int dist[MAXN];
bool vis[MAXN];
queue<int> q;

void calc_ranges(){
    for(int i=1;i<=n;i++){
        previous_hill[i]=1;
        next_hill[i]=n;

        for(int f=i+1;f<=n;f++){
            next_hill[i]=f;
            if(h[f]>=h[i])break;
        }

        for(int f=i-1;f>=1;f--){
            previous_hill[i]=f;
            if(h[f]>=h[i])break;
        }
    }
}

bool cross(hill fr,hill sc){
    if(fr.r+1<sc.l)return false;
    if(sc.r+1<fr.l)return false;

    return true;
}

void bfs(int x){
    for(int i:g[x]){
        if(vis[i])continue;

        vis[i]=true; dist[i]=dist[x]+1;
        q.push(i);
    }
}

void build_graph(){
    for(int i=1;i<=n;i++){
        for(int f=1;f<=n;f++){
            if(cross(s[i],s[f])){
                g[i].push_back(f);
                g[f].push_back(i);
            }
        }

        if(s[i].l==1){
            dist[i]=1; vis[i]=true;
            q.push(i);
        }
    }
}

void findpath(int x){
    sol.push_back(x);

    if(dist[x]==0)return;

    for(int i:g[x]){
        if(dist[i]+1==dist[x]){
            findpath(i); return;
        }
    }
}

bool check(long long maxt,bool solution){

    for(int i=1;i<=n;i++){
        int last=i;
        for(int f=i;f<=n and t[f]-t[i]<=maxt;f++)last=f;
        s[i].r=min(next_hill[i],last);


        for(int f=i;f>=1 and t[i]-t[f]<=maxt;f--)last=f;
        s[i].l=max(previous_hill[i],last);

        g[i].clear(); vis[i]=false;
    }

    build_graph();

    while(!q.empty()){
        bfs(q.front());
        q.pop();
    }

    int res=n+1,endv=0;
    for(int i=1;i<=n;i++){
        if(s[i].r==n and dist[i]<res){
            res=dist[i]; endv=i;
        }
    }

    if(solution)findpath(endv);

    return res<=k;
}

long long bin(){
    long long l=0,r=t[n]+5,mid;

    while(l+1<r){
        mid=(l+r)/2;

        if(check(mid,false)){
            r=mid;
        }else{
            l=mid;
        }
    }

    return r;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<=n;i++){
        cin>>h[i];
    }
    h[0]=h[n+1]=inf;

    for(int i=2;i<=n;i++){
        cin>>t[i];
        t[i]+=t[i-1];
    }

    calc_ranges();
    ans=bin();
    
    if(ans==t[n]+5){
        cout<<"-1\n";
        return 0;
    }

    check(ans,true);
    while(sol.size()<k)sol.push_back(n);

    cout<<ans<<"\n";
    for(int i:sol)cout<<i<<" ";
    cout<<"\n";

    return 0;
}