/* the checker has three arguments:
   - first - name of the input file
   - second - name of the correct output file
   - third - name of the contestant output file */

#include<iostream>
#include<algorithm>
#include<stack>

#define MAXN 1000007
using namespace std;

const int inf=1e9+7;

int n,k,p[MAXN];
long long h[MAXN],t[MAXN];
long long otg,res;
bool used[MAXN];

int pr[MAXN],nxt[MAXN],toadd[MAXN],curr;
stack<int> st;

void calc(){
    st.push(0);

    for(int i=1;i<=n;i++){
        while(!st.empty() and h[i]>h[st.top()]){
            st.pop();
        }
        pr[i]=st.top();
        st.push(i);
    }

    while(!st.empty())st.pop();

    st.push(n+1);
    for(int i=n;i>=1;i--){
        while(!st.empty() and h[i]>h[st.top()]){
            st.pop();
        }
        nxt[i]=st.top();
        st.push(i);
    }

    int pt=0;
    for(int i=1;i<=n;i++){
        while(pt<n and t[pt+1]-t[i]<=otg)pt++;
        nxt[i]=min(nxt[i],pt);
    }

    pt=n+1;
    for(int i=n;i>=1;i--){
        while(pt>1 and t[i]-t[pt-1]<=otg)pt--;
        pr[i]=max(pr[i],pt);
    }

    for(int i=1;i<=n;i++){
        if(!used[i])continue;

        toadd[pr[i]]++;
        toadd[nxt[i]+1]--;
    }
}

void prnt(double points,const char message[]) {
    fprintf(stdout,"%f\n",points);
    fprintf(stderr,"%s\n",message);
    exit(0);
}

int main (int argc, char** argv) {
    if(argc<4)prnt(0,"Missing files!");

    FILE *in,*ans,*out;

    in=fopen(argv[1],"rt");
    if(!in)prnt(0,"Could not open input file!");
    ans=fopen(argv[2],"rt");
    if(!ans)prnt(0,"Could not open correct output!");
    out=fopen(argv[3],"rt");
    if(!out)prnt(0,"Could not open contestant output!");

    if(fscanf(in,"%d",&n)!=1)prnt(0,"Could not read input!");
    if(fscanf(in,"%d",&k)!=1)prnt(0,"Could not read input!");

    for(int i=1;i<=n;i++){
         if(fscanf(in,"%d",&h[i])!=1)prnt(0,"Could not read input!");
    }
    h[0]=h[n+1]=inf;

    for(int i=2;i<=n;i++){
         if(fscanf(in,"%d",&t[i])!=1)prnt(0,"Could not read input!");
         t[i]+=t[i-1];
    }

    if(fscanf(ans,"%ld",&res)!=1)prnt(0,"Could not read answer!");
    if(fscanf(out,"%ld",&otg)!=1)prnt(0,"Could not read output!");

    if(res!=otg)prnt(0,"Wrong answer!");
    if(res==-1)prnt(1,"Correct!");

    for(int i=1;i<=k;i++){
        if(fscanf(out,"%ld",&p[i])!=1)prnt(0.5,"Partially correct!");
        if(p[i]<1 or p[i]>n)prnt(0.5,"Partially correct!");

        used[p[i]]=true;
    }

    calc();
    for(int i=1;i<=n;i++){
        curr+=toadd[i];
        if(curr<=0)prnt(0.5,"Partially correct!");
    }

    prnt(1,"Correct!");

    return 0;
}

